










#open "VRcaML";;
#open "default";;
#open "exceptions";;
#open "basic_types";;
#open "font";;
#open "fonts";;
#open "colors";;
#open "vrml_objects_pre";;
#open "calc_3D";;
#open "vrml_objects_post";;
#open "positionables";;
#open "geometrics";;
#open "geometric_properties";;
#open "map";;
#open "complex_geometrics";;
#open "map_complex";;
#open "lights";;
#open "map_light";;
#open "sound";;


(* get_x1 : frame -> float *)
let get_x1 frame =
    match frame.width with
      x , _ -> x
;;

(* get_x2 : frame -> float *)
let get_x2 frame =
    match frame.width with
      _ , x -> x
;;

(* get_y1 : frame -> float *)
let get_y1 frame =
    match frame.height with
      y , _ -> y
;;

(* get_y2 : frame -> float *)
let get_y2 frame =
    match frame.height with
      _ , y -> y
;;

(* get_z1 : frame -> float *)
let get_z1 frame =
    match frame.depth with
      z , _ -> z
;;

(* get_z2 : frame -> float *)
let get_z2 frame =
    match frame.depth with
      _ , z -> z
;;


(* place_top : vrml_object -> vrml_object -> vrml_object *)
let place_top object of_object =
    let y1 = abs_float (get_y1 (get_resize_frame object))
    and y2 = get_y2 of_object.frame
    in
       translation object 0.0 (y1 +. y2) 0.0
;;

(* place_bottom : vrml_object -> vrml_object -> vrml_object *)
let place_bottom object of_object =
    let y1 = get_y1 of_object.frame
    and y2 = get_y2 (get_resize_frame object)
    in
       translation object 0.0 (y1 -. y2) 0.0
;;

(* place_right : vrml_object -> vrml_object -> vrml_object *)
let place_right object of_object =
    let x1 = abs_float (get_x1 (get_resize_frame object))
    and x2 = get_x2 of_object.frame
    in
       translation object (x1 +. x2) 0.0 0.0
;;

(* place_left : vrml_object -> vrml_object -> vrml_object *)
let place_left object of_object =
    let x1 = get_x1 of_object.frame
    and x2 = get_x2 (get_resize_frame object)
    in
       translation object (x1 -. x2) 0.0 0.0
;;

(* place_front : vrml_object -> vrml_object -> vrml_object *)
let place_front object of_object =
    let z1 = abs_float (get_z1 (get_resize_frame object))
    and z2 = get_z2 of_object.frame
    in
       translation object 0.0 0.0 (z1 +. z2)
;;

(* place_behind : vrml_object -> vrml_object -> vrml_object *)
let place_behind object of_object =
    let z1 = get_z1 of_object.frame
    and z2 = get_z2 (get_resize_frame object)
    in
       translation object 0.0 0.0 (z1 -. z2)
;;


(* stick_top : vrml_object -> vrml_object -> vrml_object *)
let stick_top object of_object =
    add_child of_object (place_top object of_object)
;;

(* stick_bottom : vrml_object -> vrml_object -> vrml_object *)
let stick_bottom object of_object =
    add_child of_object (place_bottom object of_object)
;;

(* stick_right : vrml_object -> vrml_object -> vrml_object *)
let stick_right object of_object =
    add_child of_object (place_right object of_object)
;;

(* stick_left : vrml_object -> vrml_object -> vrml_object *)
let stick_left object of_object =
    add_child of_object (place_left object of_object)
;;

(* stick_front : vrml_object -> vrml_object -> vrml_object *)
let stick_front object of_object =
    add_child of_object (place_front object of_object)
;;

(* stick_behind : vrml_object -> vrml_object -> vrml_object *)
let stick_behind object of_object =
    add_child of_object (place_behind object of_object)
;;
