









(**************************************************************************)
(* $Id: world.ml,v 1.2 1997/04/24 17:59:31 doub Exp $                     *)
(* Creation and manipulation of VRML worlds                               *)
(**************************************************************************)

#open "VRcaML";;
#open "default";;
#open "exceptions";;
#open "basic_types";;
#open "font";;
#open "fonts";;
#open "colors";;
#open "vrml_objects_pre";;
#open "calc_3D";;
#open "vrml_objects_post";;
#open "positionables";;
#open "geometrics";;
#open "geometric_properties";;
#open "map";;
#open "complex_geometrics";;
#open "map_complex";;
#open "lights";;
#open "map_light";;
#open "sound";;
#open "frame_manipulations";;
#open "specials";;


(**************************************************************************)
(* VRML world                                                             *)
(**************************************************************************)

(* new_vrml_world :
   string list -> string -> vrml_object -> vrml_special list
-> animation list -> vrml_world *)
let new_vrml_world info title tree specials animations =
    { info       = info ;
      title      = title ;
      tree       = tree ;
      specials   = specials ;
      animations = animations }
;;

(* set_info : vrml_world -> string list -> vrml_world *)
let set_info world info =
    new_vrml_world info world.title world.tree
                   world.specials world.animations
;;

(* set_title : vrml_world -> string -> vrml_world *)
let set_title world title =
    new_vrml_world world.info title world.tree
                   world.specials world.animations
;;

(* set_tree : vrml_world -> vrml_object -> vrml_world *)
let set_tree world tree =
    new_vrml_world world.info world.title tree
                   world.specials world.animations
;;

(* set_specials : vrml_world -> vrml_special list -> vrml_world *)
let set_specials world specials =
    new_vrml_world world.info world.title world.tree
                   specials world.animations
;;

(* add_special : vrml_world -> vrml_special -> vrml_world *)
let add_special world special =
    new_vrml_world world.info world.title world.tree
                   (special::(world.specials)) world.animations
;;

(* set_animations : vrml_world -> animation list -> vrml_world *)
let set_animations world animations =
    new_vrml_world world.info world.title world.tree
                   world.specials animations
;;

(* add_animation : vrml_world -> animation -> vrml_world *)
let add_animation world animation =
    new_vrml_world world.info world.title world.tree world.specials
                   (animation::(world.animations))
;;

